var focused = null;
var myEditor = null;
var pageData = "";
var needToConfirm = true;
var textareaChanged = false;
var inactive=0;
var logoutCntr=120;
var webStorage=false;
var propChanged=false;
var logo=getCookie('comp', 'logo');
var nRowIndex=0;
var loTimer = null;
var SESSION_TIMEOUT = 40; // Minutes
var ACTIVE_CALL_INTERVAL = 10; // Minutes
var logoVersion = "";
var editBgColour = "#E3F2FD";

var isMobile = false;
var isDragDropSupported = true;

var editorFonts = 'Verdana, Arial, Helvetica, sans-serif';
var defFontName = 'Verdana';

if(typeof(Storage)!=="undefined") {webStorage=true;}

var objToDisable=null;
function disableWithDelay(obj,delay) {
	objToDisable = obj;
	
	if (delay==undefined) {
		delay=20;
	}

	setTimeout("$(objToDisable).prop('disabled',true); objToDisable=null;", 20);
}

var objToFocus=null;
function setFocusWithDelay(obj,delay) {
	objToFocus = obj;
	
	if (delay==undefined) {
		delay=500;
	}

	setTimeout("$(objToFocus).focus(); objToFocus=null;", delay);
}

function isValidTime(t) {
	pattern = /^((0?[0-9]|1[0-2])(:[0-5][0-9])?(\s)?(am|pm)?|(0?[0-9]|1[0-9]|2[0-3])(:[0-5][0-9])?)$/i;
	return pattern.test(t.trim());
}

function roundUpCurrency(amt) {
	if (amt<1000) {
		amt = Math.ceil(amt/10)*10;
	}
	else if (amt<10000) {
		amt = Math.ceil(amt/100)*100;
	}
	else {
		amt = Math.ceil(amt/1000)*1000;
	}
	
	return amt;
}

function selectAll() {
	sel = document.getElementsByName('sel');
	selAll = document.getElementById('selAll');	
	for(var i=0; i<sel.length; i++) {
		sel[i].checked=selAll.checked;
	}
}

function anySelected() {
	sel = document.getElementsByName('sel');
	for(var i=0; i<sel.length; i++) {
		if (sel[i].checked) {
			return true;
		}
	}
	return false;
}

function formatNum(num, dec, curr) {
	var removeZeros = (dec<0);
	dec = Math.abs(dec);

	if(num===null) {
		return '';
	}
	
	sTmp=(num+'').replace(/,/g, '');
	num=parseFloat(sTmp);

	if(isNaN(num)) {
		return '';
	}
	
	res=num.toFixed(dec);

	if(dec==0) {
		res += '.00';
	}
	
	res=res.replace(/\d(?=(\d{3})+\.)/g, '$&,'); 

	if(dec==0) {
		res=res.replace('.00', '');
	}
	
	if(curr==true) {
		res='$'+res;
	}

	while (removeZeros && res!='' && res.indexOf('.')>0 && (res.charAt(res.length-1)=='0' || res.charAt(res.length-1)=='.')) {
		res = res.substring(0, res.length-1);
	}
	
	return res;
}

function formatCurrencyNoDecimal(n) {
	var num = parseFloat(n);
	num = isNaN(num) || num === '' || num === null ? 0.00 : num;
	tmp = num.toFixed(0) + '.00';
	tmp = '$' + tmp.replace(/\d(?=(\d{3})+\.)/g, '$&,');
	tmp = tmp.replace('.00', '');
	return tmp;
}

function formatCurrency(n) {
	var num = parseFloat(n);
	num = isNaN(num) || num === '' || num === null ? 0.00 : num;
	
	return '$' + num.toFixed(2).replace(/\d(?=(\d{3})+\.)/g, '$&,');
}

function formatCurrencyEdit(num) {
	num = isNaN(num) || num === '' || num === null ? 0.00 : num;
	return parseFloat(num).toFixed(2);
}

function formatPhone(str) {
	var tmp = '';
	for (var i=0; i<str.length; i++) {
		var ch = str.charAt(i);
		
		if (ch>='0' && ch<='9') {
			tmp += ch;
		}
	}
	
	if (tmp.length>=10) {
		var cntr = 0;
		var formatted = '';
		for (var i=tmp.length-1; i>=0; i--) {
			formatted = tmp.charAt(i) + formatted;
			cntr++;
			
			if (cntr==4) {
				formatted = '-' + formatted;
			}
			if (cntr==7) {
				formatted = ') ' + formatted;
			}
			if (cntr==10) {
				formatted = '(' + formatted;
			}
		}
		
		return formatted;
	}
	else {
		return str;
	}
}

function setVisible(id, visible) {
	var o = document.getElementById(id);
	if (o!=null) {
		o.style.display=visible;
	}
}

function toggleVisibility(id, visible) {
	var o = document.getElementById(id);
	if (o!=null) {
		if (o.style.display=='none') {
			setVisible(id, visible);
		}
		else {
			setVisible(id, 'none');
		}
	}
}

function setEnabled(id, enabled) {
	var o = document.getElementById(id);
	if (o!=null) {
		o.disabled = !enabled;
//		o.readOnly = !enabled;
		if (enabled) {
			o.style.backgroundColor = editBgColour;
			o.style.color = '#6c757d';
		}
		else {
			if (o.type!=undefined) {
				o.style.backgroundColor = '#eee';
			}
			o.style.color = '#444';
		}

		if (o.type=='textarea') {
			var ed = tinymce.get(id);
			if (ed!=null) {
				if (enabled) {
					ed.getBody().style.backgroundColor = editBgColour;
				}
				else {
					ed.getBody().style.backgroundColor = "#eee";
				}
			}
		}
	}
}

function closeAllMenus() {
	$('.menuContainer').css("display", "none");
}

function debug(str) {
	if (document.URL.indexOf('localhost')>=0) {
		o = document.getElementById('debug');
		if (o!=null) {o.innerHTML = str;}
	}
}

function keepActive(path) {
	$.ajax({
		url: path + "/active.htm",
		context: document.body
	}).done(function(data) {
		if (loTimer!=null) {
			clearTimeout(loTimer);
		}
		logoutCntr = 120;
		inactive = 0;
		autoLogout(path);
	});
}

function logout(path) {
	needToConfirm = false;
	window.location = path+"/logout";
}

function logoutTimer(path) {
	$('#inactiveTime').html(logoutCntr);
	logoutCntr--;
	if (logoutCntr<0) {
		logout(path);
	}
	else {
		loTimer = setTimeout("logoutTimer('"+path+"');",1000); // Check every second
	}
}

/*
function autoLogout(path) {
	if (inactive>13) {
		inactive=0;
	}
	
	// Logout after 20 minutes
	if ((textareaChanged==false) && (inactive==10)) {
		nsm('confInactive');
		logoutTimer(path);
	}
	else if ((textareaChanged==false) && (inactive>11)) {
		logout(path);
	}
	else {
		setTimeout("autoLogout('"+path+"');",120*1000); // Check every 2 minutes
	}
	
	if (inactive<13) {
		inactive++;
	}
}
*/

function autoLogout(path) {
	// Keep session active by sending a request every 20 minutes
	if (inactive % ACTIVE_CALL_INTERVAL == (ACTIVE_CALL_INTERVAL - 1)) {
		// Do not log out if data is changed. Just reset the counter.
		if (textareaChanged==true) {
			inactive = 0;
		}

		$.ajax({
			url: path + "/active.htm",
			context: document.body
		});
	}
	
	// Logout after 40 minutes
	if ((textareaChanged==false) && (inactive==SESSION_TIMEOUT)) {
		$('#inactiveSessionWarning').openDlg();
		logoutTimer(path);
	}
	else if ((textareaChanged==false) && (inactive>SESSION_TIMEOUT+2)) {
		logout(path);
	}
	else {
		setTimeout("autoLogout('"+path+"');",60*1000); // Check every minute
	}
	
	if (inactive<SESSION_TIMEOUT+4) {
		inactive++;
	}
}


function getCookie(c_name,def_val) {
	if (webStorage) {
		value = localStorage.getItem(c_name);
		if (value==null) {
			value=def_val;
		}
		return value;
	}
	else {
		var i,x,y,ARRcookies=document.cookie.split(";");
		for (var i=0;i<ARRcookies.length;i++) {
			x=ARRcookies[i].substr(0,ARRcookies[i].indexOf("="));
			y=ARRcookies[i].substr(ARRcookies[i].indexOf("=")+1);
			x=x.replace(/^\s+|\s+$/g,"");
			if (x==c_name) {
				return unescape(y);
			}
		}
		return def_val;
	}
}

function setCookie(c_name,value) {
	if (webStorage) {
		localStorage.setItem(c_name,value);
	}

	// Always set the cookie. It is required to get company code in Servlet.
	var c_value=escape(value);
	document.cookie=c_name + "=" + c_value + "; path=/; SameSite=None; Secure";
}

function setValue(c_name,value) {
	if (webStorage) {
		localStorage.setItem(c_name,value);
	}
	else {
		var c_value=escape(value);
		document.cookie=c_name + "=" + c_value + "; path=/; SameSite=None; Secure";
	}
}

function expandAll() {
	$('.tree-item, .collapse-group-item').collapse('show');
}

function collapseAll() {
	$('.tree-item, .collapse-group-item').collapse('hide');
}

function initCollapsables() {	
	divs = document.getElementsByTagName('div');
	for(var i=0; i<divs.length; i++) {
		if (divs[i].className == 'collapsable') {
			if (getCookie(divs[i].id.substring(3),'')=='') collapse(divs[i].id.substring(3),false);
			else if (getCookie(divs[i].id.substring(3),'')=='none') toggle(divs[i].id.substring(3),false);
		}
	}
}

function initCollapsablesDefaultClose() {	
	divs = document.getElementsByTagName('div');
	for(var i=0; i<divs.length; i++) {
		if (divs[i].className == 'collapsable') {
			if (getCookie(divs[i].id.substring(3),'')=='block') {
				toggle(divs[i].id.substring(3),false);
			}
		}
	}
}

function onFormSubmit() {
	needToConfirm = false;
}

function confirmExit() {
	if (needToConfirm) {
		var errors=document.getElementsByTagName("span");
		var hasError = false;
		for(var i=0;i<errors.length;i++) {
			if ((errors[i].className.indexOf('errors') > -1) && (errors[i].innerHTML!=''))
				hasError = true;
		}
/*
alert(pageData + '\n\r------------------------------\n\r' + getPageData());
alert(pageData!=getPageData());
alert(textareaChanged);
alert(hasError);
*/
		if ((pageData!=getPageData()) || textareaChanged || hasError) {
			return "You have attempted to leave this page.  If you have made any changes to the fields without clicking the Save button, your changes will be lost.  Are you sure you want to exit this page?";
		}
	}
}

function getPageData() {
	var data="";

	var inputs=document.getElementsByTagName("input");
	for(var i=0;i<inputs.length;i++) {
		if (inputs[i].className.indexOf('nocheck') == -1) {
			if (inputs[i].className.indexOf('inp') > -1)
				data = data + inputs[i].value + "-";
	
			if (inputs[i].type=='checkbox') {
				data = data + inputs[i].checked + "-";
			}
		}
	}

	var inputs=document.getElementsByTagName("select");
	for(var i=0;i<inputs.length;i++) {
		if (inputs[i].className.indexOf('ui-') == -1) {
			if (inputs[i].className.indexOf('nocheck') == -1) {
				if (inputs[i].className.indexOf('inp') > -1) {
					data = data + inputs[i].selectedIndex + "-";
				}
			}
		}
	}

	return data;
}

function resetFileName(field) {
	document.getElementById(field+'inpdiv').style.display='inline';
	document.getElementById(field+'dispdiv').style.display='none';
	document.getElementById(field+'upload').value='true';
	return false;
}

function disableEnterKey(e) {
	var key;
	
	if(window.event)
    	key = window.event.keyCode;     //IE
    else
    	key = e.which;     //firefox

	if(key == 13)
    	return false;
	else
    	return true;
}

function setupSimpleEditor(w,h,cont_css,sel,paste_txt_only) {
	if (sel==null || sel=="") {
		sel='textarea:not(.mceNoEditor)';
	}
	
	paste_plugin = '';
	if (paste_txt_only==null || paste_txt_only==undefined || paste_txt_only==true) {
		paste_plugin = ',paste';
	}

	tinymce.init({
		selector: sel,
		theme: "modern",
		plugins : 'advlist,autolink,link,image,lists,charmap,print,preview,textcolor,colorpicker,spellchecker' + paste_plugin,
		menubar : false,
		statusbar : false,
		width: w,
		height: h,
		toolbar_items_size: 'small',
		browser_spellcheck : true,
		document_base_url: "http://www.powerstrata.ca/no-root",
		relative_urls: false,
		remove_script_host: false,
		content_css : cont_css,
		
//		paste_as_text: true,
		branding: false,

//		force_br_newlines : true,
//		force_p_newlines : false,
		force_br_newlines : false,
		force_p_newlines : true,
		
		paste_retain_style_properties: "color background background-color",

		forced_root_block : 'p', // Needed for 3.x
		
		toolbar: [
			"bold italic underline strikethrough | alignleft aligncenter alignright | bullist numlist | outdent indent blockquote | undo redo | link unlink",
			"forecolor | backcolor | fontselect | fontsizeselect"
		],
	
		setup: function(editor) {
			editor.on('keyup', function(e) {
				myCustomOnChangeHandler();
			});

			editor.on('keydown', function(e) {
				if (e.keyCode==9) {
					editor.execCommand('mceInsertContent', false, '&emsp;&emsp;');
					e.preventDefault();
				}
			});
		}
	 });
}

function setupEditor(w,h,cont_css,mnu,mnuBar,extraSetup,extraButtons,paste_txt_only, defFontSize, onInit) {
	paste_plugin = '';
	if (paste_txt_only==null || paste_txt_only==undefined || paste_txt_only==true) {
		paste_plugin = ',paste';
	}

	if (defFontSize==undefined) {
		defFontSize = '12';
	}
	
	tinymce.init({
		selector: "textarea:not(.mceNoEditor)",

		format_empty_lines: true,

		editor_deselector: "mceNoEditor",
		plugins : 'noneditable,advlist,autolink,link,image,lists,charmap,print,preview,textcolor,colorpicker,spellchecker,table' + paste_plugin,
		statusbar : false,
		width: w,
		height: h,
		toolbar_items_size: 'small',
		browser_spellcheck : true,
		document_base_url: "http://www.powerstrata.ca/no-root",
		relative_urls: false,
		remove_script_host: false,
		content_css: cont_css,
		toolbar_sticky: true,
		
//		contextmenu: 'link useBrowserSpellcheck',
		contextmenu: false,
		
		mobile: {
			menu : mnu, 
			menubar: mnuBar,
			toolbar_sticky: true
		},
		
//		paste_as_text: true,
		branding: false,

//		force_br_newlines : true,
//		force_p_newlines : false,
		force_br_newlines : false,
		force_p_newlines : true,

		forced_root_block : 'p', // Needed for 3.x
		content_style: 'p {margin: 0; padding: 0;} body {font-family:' + defFontName + ', Verdana, Arial, Helvetica, sans-serif; font-size: ' + defFontSize + 'pt; color: #444;}',

		menu : mnu, 
		menubar: mnuBar,

		toolbar: [
		    extraButtons + "bold italic underline strikethrough | alignleft aligncenter alignright | bullist numlist | outdent indent blockquote | undo redo | link unlink",
		    "forecolor | backcolor | fontselect | fontsizeselect"
		],

		setup: function(editor) {
			editor.on('keyup', function(e) {
				myCustomOnChangeHandler();
			});
			
			editor.on('keydown', function(e) {
				if (e.keyCode==9) {
					editor.execCommand('mceInsertContent', false, '&emsp;&emsp;');
					e.preventDefault();
				}
			});
			
			extraSetup(editor);

			editor.ui.registry.addMenuItem('useBrowserSpellcheck', {
				text: 'Use "Ctrl+Right Click" for spellchecker',
				onAction: function () {
					editor.notificationManager.open({
						text: 'To access the spellchecker, hold the Control (Ctrl) key and right-click on the misspelt word.',
						type: 'info',
						timeout: 5000,
						closeButton: true
					});
				}
			});
			
			editor.ui.registry.addContextMenu('useBrowserSpellcheck', {
				update: function (node) {
					return editor.selection.isCollapsed() ? ['useBrowserSpellcheck'] : [];
				}
			});

			if (onInit!=undefined) {
				editor.on('init', function() {
					setMCEFontName(this, editorFonts)
					onInit(editor);
				});
			}
			else if (defFontSize!=undefined) {
				editor.on('init', function() {
					setMCEFontName(this, defFontName)
				});
			}
			else {
				editor.on('init', function() {
					setMCEFontName(this, editorFonts)
				});
			}

		}
	 });
}

function setMCEFontName(edt, fontName) {
	// For some strange reason, the font name and size is being set even 
	// without calling the execCommand.
//	edt.execCommand("fontName", false, fontName);
}

function setMCEFontSize(edt, fontSize) {
	// For some strange reason, the font name and size is being set even 
	// without calling the execCommand.
//	edt.execCommand("fontSize", false, fontSize);
}
















function doSubmit(formId, action) {
	var form = document.getElementById(formId);
	if (action!=undefined && action!="") {
		form.action = action;
	}
	form.submit();
}

function goBack(url) {
	if (url!=null && url!='') {
		window.location=url;
	}
	else {
		history.go(-1);
	}
	return true;
}

function isVisible(obj) {
	return (obj.className.indexOf('d-none')<0);
}

function focusFirstInput() {
	var lst = $('.focus, .focus-if-blank');

	if (lst.length>0) {
		for (var i=0; i<lst.length; i++) {
			if (lst[i].disabled==false && lst[i].readOnly==false && isVisible(lst[i])) {
				if ($(lst[i]).hasClass('focus')) {
					$(lst[i]).focus();
					return;
				}
				
				if ($(lst[i]).hasClass('focus-if-blank') && $(lst[i]).val()=='') {
					$(lst[i]).focus();
					return;
				}
			}
		}
	}
}

function setFocus(id) {
	var e = document.getElementById(id);
	if (e!=null) {
		e.focus();
		focused = e;
	}
}

function updateAddress(name, address, formatted) {
	geocoder.getLatLng(address, function(location) {
		map.setCenter(location, 15);
		var marker = new google.maps.Marker(location);
		map.addOverlay(marker);
		marker.openInfoWindowHtml(getAddressInfo(name, formatted));
	});
}

function getAddressInfo(name, address) {
	return "<b>" + name + "</b><br/>" + address;
}

$(document).ready(
	function() {
		focusFirstInput();

		if (typeof autoRun === "function") {
			autoRun();
		}

		logo=getCookie('comp', 'logo');
		if (logo!='' && logo!=null) {
			var o=document.getElementById("logo");
			o.src="/logo-" + logoVersion + "/" + logo + ".png";
		} 

		if (propChanged) {
			$('#propertyChangeNoticeDlg').openDlg();
		}
	}
);

function showElementEx(element, disp) {
	var o = document.getElementById(element);
	o.style.display = disp;
}

function showElement(element) {
	showElementEx(element, 'inline');
}

function hideElement(element) {
	var o = document.getElementById(element);
	if (o!=null) {
		o.style.display = 'none';
	}
}

function decodeHtmlStr(str) {
//	str = str.replace("&amp;", "&");
//	str = str.replace("&nbsp;", " ");
//	str = str.replace("&gt;", ">");
//	str = str.replace("&lt;", "<");
	
	str = psReplaceAll(str, "&amp;", "&");
	str = psReplaceAll(str, "&nbsp;", " ");
	str = psReplaceAll(str, "&gt;", ">");
	str = psReplaceAll(str, "&lt;", "<");

	return str;
}

// Notification confirmation
function sendConf(recipients, id, url) {
	if (id!='') {
		document.getElementById(id).style.visibility="visible";
	}	
	window.location=url;
	return true;
}

// Autocomplete
function removeQuote(str) {
	str=str.replace(/"/g,"_");
	str=str.replace(/'/g,"_");
	return str;
}

function addButton(fullName, code, input) {
	var i = document.getElementById(input);
	var btnPanel = document.getElementById(input + "Panel");	

	if ((i.img!=undefined) && (btnPanel!=null) && (document.getElementById(input + '_' + code) == null)) {
		if (i.eventHandler!=null) {
			i.eventHandler(input, "BeforeAdd", fullName, code);
		}

		expandHTML = "<a href=\"javascript:delButton('" + removeQuote(fullName) + "', '" + code + "', '" + input + "', true);expandGroup('" + input + "', '" + code + "');\">" + 
						"<img src='" + i.expandImg + "' title='Expand'/>" +
					 "</a>";

		if (i.expandUrl==null || i.expandUrl=="" || (code.indexOf(".PERSON.")>-1)) {
			expandHTML = "";
		}

		btnPanel.innerHTML = btnPanel.innerHTML + 
			"<div id='" + input+ "_" + code + "' class='userGroupBtn'>" +
				"<a href=\"javascript:delButton('" + removeQuote(fullName) + "', '" + code + "', '" + input + "', true);\">" + 
					"<img src='" + i.img + "' title='Remove' />" +
				"</a>" + 

				expandHTML +
				
				"<span>" + 
					fullName +
				"</span>" + 
			"</div>";

		if (i.eventHandler!=null) {
			i.eventHandler(input, "AfterAdd", fullName, code);
		}
	}
}

function delButton(fullName, code, input, focus) {
	var i = document.getElementById(input);
	var button = document.getElementById(input + "_" + code);
	var btnPanel = document.getElementById(input + "Panel"); 
	if (btnPanel != null) {
		if (i.eventHandler!=null) {
			i.eventHandler(input, "BeforeDel", fullName, code);
		}
	
		if (button!=null) { 
			btnPanel.removeChild(button);
			rebuildButtonsStr(input);
		
			if (focus==true) setFocus(input);	
			
			if (i.eventHandler!=null) {
				i.eventHandler(input, "AfterDel", fullName, code);
			}
		}
	}
}

function expandGroup(input, grp) {
	var i = document.getElementById(input);
	
	$.ajax({
		url: i.expandUrl + "?grp=" + encodeURIComponent(grp)
	}).done(function(data) {
			var obj = JSON.parse(data);
			for (var i=0; i<obj.suggestions.length; i++) {
				tmp=obj.suggestions[i].data.split("|");
			name = tmp[0];		
			code = tmp[1]; 
			addButton(name, code, input);
			}
		rebuildButtonsStr(input);
	});
}

function rebuildButtonsStr(input) {
	var btnPanel = document.getElementById(input + "Panel"); 
	var btnStr   = document.getElementById(input + "List");
	var nodes    = btnPanel.childNodes;
	btnStr.value = '';
	for(var i=0; i<nodes.length; i++) {
		if (nodes[i].lastChild != null) {
			var title = nodes[i].lastChild.innerHTML;
			title = decodeHtmlStr(title);
			var code = nodes[i].id.split("_");
			qCode = code[1];
			for (var j=2; j<code.length; j++) {
				qCode = qCode + "_" + code[j]
			}
			btnStr.value = btnStr.value + title + "|" + qCode + ";";
		}  
	}
}

function rebuildButtonPanel(input) {
	var btnPanel = document.getElementById(input + "Panel"); 
	var btnStr   = document.getElementById(input + "List");

	if (btnPanel != null) {
		btnPanel.innerHTML = "<span style='float:left;'></span>";
	}
	else {
		return;
	}
	
	var arr = btnStr.value.split(";");
	for (var i=0; i<arr.length; i++) {
		if (arr[i] != "") {
			var data = arr[i].split("|");
			if (data[1] != '') {
				addButton(data[0], data[1], input);
			}
		}
	}
}

function clearButtonPanel(input) {
	var btnPanel = document.getElementById(input + "Panel"); 
	var btnStr   = document.getElementById(input + "List");

	btnPanel.innerHTML = "<span style='float:left;'></span>";	
	btnStr.value = "";
}

function formatName(str, email) {
	if (email=='N') {
		return '<span class="NameNoEmail">&nbsp;</span>' + str;
	}
	else if (email=='Y') {
		return '<span class="NameEmail">&nbsp;</span>' + str;
	}
	else if (email=='B') {
		return '<span class="NameMsgBox">&nbsp;</span>' + str;
	}
	else {
		return '<span class="Name">&nbsp;</span>' + str;
	}
}

function setLocalAutoComp(input, data, onSelectProc, srchMethod, formatProc) {
	var parent = $('#' + input + 'Cont');

	obj = data[0];
	if (obj.hasOwnProperty('value')) {
		if (data[data.length-1].value=='') {
			arr = data.slice(0,data.length-1);
		}
		else {
			arr = data;
		}
	}
	else {
		if (data[data.length-1]=='') {
			arr = data.slice(0,data.length-1);
		}
		else {
			arr = data;
		}
	}
			
	a = $('#'+input).autocomp({
		autoSelectFirst: true,
		minChars: 0,
		appendTo: parent,
		noValSuggest: true,
		suggestOnFocus: false,
		triggerSelectOnValidInput: false,
		preventBadQueries: false,
		searchMethod: srchMethod,
		lookup: arr,
		beforeRender: function(container) {
			nRowIndex=0;
		},
		onSelect: function (suggestion) {
			if (onSelectProc!=null) {
				onSelectProc(suggestion);
			}
		},
		formatResult: function(suggestion, currentValue) {
			str = suggestion.value;
			
			if (str.indexOf("|") != -1) {
				tmp=str.split("|");
				code = tmp[0];
				name = tmp[1];
			} else {
				code = str;
				name = str;
			}
			
			nRowIndex++;
			var formatted = '<div class="ac_';
			if (nRowIndex%2==0) {
				formatted += 'even';
			}
			else {
				formatted += 'odd';
			}
				
			if (formatProc!=null) {
				name = formatProc(name);
			}

			formatted += '">' + name + '</div>';
			return formatted;
		}
	});

	a.autocomp().preloadSuggestions();
}


function setAutoComplete(input, url, data, property, proc, img, sec, rol, psb, showButton, expandUrl, expandImg) {
	var i = document.getElementById(input);
	if (i==null)
		return;
	
	i.eventHandler = proc;
	i.img = img;
	i.url = url;

	i.expandUrl = expandUrl;
	i.expandImg = expandImg;

	var propertyCombobox = null;
	
	if (property.indexOf('#')==0) {
		propertyCombobox = $(property)
		i.prop = propertyCombobox[0].value;
	}
	else {
		i.prop = property;
	}
	
	i.sec = sec;
	i.rol = rol;
	i.psb = psb;
	
	var parent = i.parentElement; // $('#' + input + 'Cont');

	a = $('#'+input).autocomp({
		autoSelectFirst: true,
		appendTo: parent,
		noValSuggest: false,
		suggestOnFocus: false,
		triggerSelectOnValidInput: true,
		preventBadQueries: false,

		paramName: 'q',
		params: {
			prop: i.prop,
			sec: i.sec,
			rol: i.rol,
			psb: i.psb
		},		
		serviceUrl: url, 
		dataType: 'json', 
		minChars: 1,
		width: 450,
		beforeRender: function(container) {
			nRowIndex=0;
		},
		onSelect: function (suggestion) {

			myId = this.id;

			itemData = suggestion.data;
			if (itemData == '') {
				return;
			}
			if (itemData.indexOf("|") != -1) {
				tmp=itemData.split("|");
				name = tmp[0];
				code = tmp[1];
			}

			if (!showButton) {
				this.value = name;
			}
			else {
				addButton(name, code, myId);
				this.value = "";
				rebuildButtonsStr(myId);
			}

			if (i.eventHandler!=null) {
				i.eventHandler(myId, "ItemSelected", name, code);
			}
		},
		formatResult: function(suggestion, currentValue) {
			name = suggestion.value;
			str = suggestion.data;
			
			if (str.indexOf("|") != -1) {
				tmp=str.split("|");
				code = tmp[1];
				email = tmp[2];
			} else {
				code = str;
				email = 'X';
			}

			nRowIndex++;
			var formatted = '<div class="ac_';
			if (nRowIndex%2==0) {
				formatted += 'even';
			}
			else {
				formatted += 'odd';
			}
				
			formatted += '">' + name + '</div>';
			return formatName(formatted, email);
		}
	});

	if (propertyCombobox!=null) {
		propertyCombobox.change(function() {
			i = document.getElementById(input);
			i.prop = propertyCombobox[0].value;
			
			$("#" + input).autocomp().clear();
	
			$("#" + input).autocomp().setOptions({
				params: {
					prop: i.prop,
					sec: i.sec,
					rol: i.rol,
					psb: i.psb
				}		
			});
	
			clearButtonPanel(input);
		});
	}

	rebuildButtonPanel(input);
}

function setAutoComplete_OLD(input, url, data, p1, proc, img, sec, rol, psb, showButton, onSelectProc) {
	var i = document.getElementById(input);
	if (i==null)
		return;
	
	i.eventHandler = proc;
	i.img = img;
	i.url = url;

	i.expandUrl = expandUrl;
	i.expandImg = expandImg;

	i.prop = $(p1)[0].value;
	i.sec = sec;
	i.rol = rol;
	i.psb = psb;
	
	var parent = $('#' + input + 'Cont');

	a = $('#'+input).autocomp({
		autoSelectFirst: true,
		appendTo: parent,
		noValSuggest: false,
		suggestOnFocus: false,
		triggerSelectOnValidInput: true,
		preventBadQueries: false,

		paramName: 'q',
		params: {
			prop: i.prop,
			sec: i.sec,
			rol: i.rol,
			psb: i.psb
		},		
		serviceUrl: url, 
		dataType: 'json', 
		minChars: 1,
		width: 450,
		beforeRender: function(container) {
			nRowIndex=0;
		},
		onSelect: function (suggestion) {

			myId = this.id;

			itemData = suggestion.data;
			if (itemData == '') {
				return;
			}
			if (itemData.indexOf("|") != -1) {
				tmp=itemData.split("|");
				name = tmp[0];
				code = tmp[1];
			}

			if (!showButton) {
				this.value = name;
			}
			else {
				addButton(name, code, myId);
				this.value = "";
				rebuildButtonsStr(myId);
			}

			if (i.eventHandler!=null) {
				i.eventHandler(myId, "ItemSelected", name, code);
			}
		},
		formatResult: function(suggestion, currentValue) {
			name = suggestion.value;
			str = suggestion.data;
			
			if (str.indexOf("|") != -1) {
				tmp=str.split("|");
				code = tmp[1];
				email = tmp[2];
			} else {
				code = str;
				email = 'X';
			}

			nRowIndex++;
			var formatted = '<div class="ac_';
			if (nRowIndex%2==0) {
				formatted += 'even';
			}
			else {
				formatted += 'odd';
			}
				
			formatted += '">' + name + '</div>';
			return formatName(formatted, email);
		}
	});

	$(p1).change(function() {
		i = document.getElementById(input);
		i.prop = $(p1)[0].value;
		
		$("#" + input).autocomp().clear();

		$("#" + input).autocomp().setOptions({
			params: {
				prop: i.prop,
				sec: i.sec,
				rol: i.rol,
				psb: i.psb
			}		
		});

		clearButtonPanel(input);
	});

	rebuildButtonPanel(input);
}


// Modal Dialog Box
// copyright 8th July 2006 by Stephen Chapman
// http://javascript.about.com/
// permission to use this Javascript on your web page is granted
// provided that all of the code in this script (including these
// comments) is used without any alteration

function E(id){return document.getElementById(id);}

function pageWidth() {
  return window.innerWidth != null? window.innerWidth: document.documentElement && document.documentElement.clientWidth ? document.documentElement.clientWidth:document.body != null? document.body.clientWidth:null;
}

function pageHeight() {return window.innerHeight != null? window.innerHeight: document.documentElement && document.documentElement.clientHeight ? document.documentElement.clientHeight:document.body != null? document.body.clientHeight:null;}

function posLeft() {return typeof window.pageXOffset != 'undefined' ? window.pageXOffset:document.documentElement && document.documentElement.scrollLeft? document.documentElement.scrollLeft:document.body.scrollLeft? document.body.scrollLeft:0;}

function posTop() {return typeof window.pageYOffset != 'undefined' ? window.pageYOffset:document.documentElement && document.documentElement.scrollTop? document.documentElement.scrollTop: document.body.scrollTop?document.body.scrollTop:0;}

function scrollFix(){var obol=E('ol');obol.style.top=posTop()+'px';obol.style.left=posLeft()+'px';}

function sizeFix(){var obol=E('ol');obol.style.height=pageHeight()+'px';obol.style.width=pageWidth()+'px';}

function kp(e){ky=e?e.which:event.keyCode;if(ky==88||ky==120)hm();return false;}

function inf(h){tag=document.getElementsByTagName('select');for(var i=tag.length-1;i>=0;i--)tag[i].style.visibility=h;tag=document.getElementsByTagName('iframe');for(var i=tag.length-1;i>=0;i--)tag[i].style.visibility=h;tag=document.getElementsByTagName('object');for(var i=tag.length-1;i>=0;i--)tag[i].style.visibility=h;}

function sm(dlg) {
	$('#'+dlg).modal('show');
}

function hm(dlg) {
	$('#'+dlg).modal('hide');
}

function setModalParam(dlg, param, value) {
	$('#' + dlg + param).html(value);
}

$.fn.openDlg = function() {
	pm = this.paramManager();

	for (var i=0; i<arguments.length; i+=2) {
		p = arguments[i];
		v = arguments[i+1];

		pm.addParam(p, v);
	}
	
	pm.populateScreen();
	
	this.modal('show');
	
	if (!isMobile) {
		setFocusWithDelay($('.' + this.attr('id') + 'DefaultBtn'));
	}
};

$.fn.closeDlg = function() {
	this.modal('hide');
}

function nsm(dlg, esc){
	if (esc=='no_esc') {
		$('#'+dlg).bPopup({opacity: 0.2, speed: 100, followSpeed: 400, escClose: false, modalClose: false});
	}
	else {
		$('#'+dlg).bPopup({opacity: 0.2, speed: 100, followSpeed: 400});
	}
}

function nhm(dlg){
	$('#'+dlg).bPopup().close();
}

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
 


// Browser detection
var BrowserDetect = {
		init: function () {
			this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
			this.version = this.searchVersion(navigator.userAgent)
				|| this.searchVersion(navigator.appVersion)
				|| "an unknown version";
			this.OS = this.searchString(this.dataOS) || "an unknown OS";
		},
		searchString: function (data) {
			for (var i=0;i<data.length;i++)	{
				var dataString = data[i].string;
				var dataProp = data[i].prop;
				this.versionSearchString = data[i].versionSearch || data[i].identity;
				if (dataString) {
					if (dataString.indexOf(data[i].subString) != -1)
						return data[i].identity;
				}
				else if (dataProp)
					return data[i].identity;
			}
		},
		searchVersion: function (dataString) {
			var index = dataString.indexOf(this.versionSearchString);
			if (index == -1) return;
			return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
		},
		dataBrowser: [
			{
				string: navigator.userAgent,
				subString: "Chrome",
				identity: "Chrome"
			},
			{ 	string: navigator.userAgent,
				subString: "OmniWeb",
				versionSearch: "OmniWeb/",
				identity: "OmniWeb"
			},
			{
				string: navigator.vendor,
				subString: "Apple",
				identity: "Safari",
				versionSearch: "Version"
			},
			{
				prop: window.opera,
				identity: "Opera"
			},
			{
				string: navigator.vendor,
				subString: "iCab",
				identity: "iCab"
			},
			{
				string: navigator.vendor,
				subString: "KDE",
				identity: "Konqueror"
			},
			{
				string: navigator.userAgent,
				subString: "Firefox",
				identity: "Firefox"
			},
			{
				string: navigator.vendor,
				subString: "Camino",
				identity: "Camino"
			},
			{		// for newer Netscapes (6+)
				string: navigator.userAgent,
				subString: "Netscape",
				identity: "Netscape"
			},
			{
				string: navigator.userAgent,
				subString: "MSIE",
				identity: "Explorer",
				versionSearch: "MSIE"
			},
			{
				string: navigator.userAgent,
				subString: "Gecko",
				identity: "Mozilla",
				versionSearch: "rv"
			},
			{ 		// for older Netscapes (4-)
				string: navigator.userAgent,
				subString: "Mozilla",
				identity: "Netscape",
				versionSearch: "Mozilla"
			}
		],
		dataOS : [
			{
				string: navigator.platform,
				subString: "Win",
				identity: "Windows"
			},
			{
				string: navigator.platform,
				subString: "Mac",
				identity: "Mac"
			},
			{
				   string: navigator.userAgent,
				   subString: "iPhone",
				   identity: "iPhone/iPod"
		    },
			{
				string: navigator.platform,
				subString: "Linux",
				identity: "Linux"
			}
		]

	};
	BrowserDetect.init();
	
function chkChange(o) {
	name = o.id;
	checked = o.checked;
	var chks = document.getElementsByTagName("input");
	
	// if main property, change all sections
	if (name.indexOf('.s,b') != -1) {
		name=name.replace('.s,b', '.');
		for(var i=0; i<chks.length; i++) {
			if (chks[i].id.indexOf(name) != -1) {
				chks[i].checked = checked;
			}
		}
	}
	// if section, change all buildings
	else if (name.indexOf(',b') != -1) {
		name=name.replace(',b', ',');
		for(var i=0; i<chks.length; i++) {
			if (chks[i].id.indexOf(name) != -1) {
				chks[i].checked = checked;
			}
		}
	}
	
	// clearing a child should clear the parent too
	if (checked==false) {
		var pat1=new RegExp('[.][0-9]+[,][0-9]+','g');
		id = o.id.replace(pat1, '.s,b');

		var pat2=new RegExp('[.][0-9]+','g');
		id = id.replace(pat2, '.s');

		var parent = document.getElementById(id);
		if (parent!=null) {
			parent.checked = false;
		}

		var pat3=new RegExp('[,][0-9]+','g');
		id = o.id.replace(pat3, ',b');

		parent = document.getElementById(id);
		if (parent!=null) {
			parent.checked = false;
		}
	}
}








/***********************************************
* Dynamic Ajax Content- � Dynamic Drive DHTML code library (www.dynamicdrive.com)
* This notice MUST stay intact for legal use
* Visit Dynamic Drive at http://www.dynamicdrive.com/ for full source code
***********************************************/

var bustcachevar=1; //bust potential caching of external pages after initial request? (1=yes, 0=no)
var loadedobjects="";
var rootdomain="http://"+window.location.hostname;
var bustcacheparameter="";

function ajaxpage(url, containerid, func){
	var page_request = false;
	if (window.XMLHttpRequest) // if Mozilla, Safari etc
			page_request = new XMLHttpRequest();
	else if (window.ActiveXObject){ // if IE
		try {
			page_request = new ActiveXObject("Msxml2.XMLHTTP");
		} 
		catch (e){
			try{
				page_request = new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch (e){}
		}
	}
	else
		return false;
		
	page_request.onreadystatechange=function(){
		if (page_request.readyState == 4 && (page_request.status==200 || window.location.href.indexOf("http")==-1)) {
			if (func!=null) {
				func(page_request.responseText);
			}
			else {
				loadpage(page_request, containerid);
			}
		}
	}
	
	if (bustcachevar) //if bust caching of external page
		bustcacheparameter=(url.indexOf("?")!=-1)? "&"+new Date().getTime() : "?"+new Date().getTime();
	page_request.open('GET', url+bustcacheparameter, true);
	page_request.send(null);
}

function loadpage(page_request, containerid){
	var d=document.getElementById(containerid);
	d.innerHTML=page_request.responseText;
	d.style.display='block';
}

function changeUrlParameter(url, param, value) {
	url = url.replace('?', '&');
	params = url.split('&');
	found = false;
	
	for (var i=1; i<params.length; i++) {
		if (params[i].indexOf(param + '=') == 0) {
			params[i] = param + '=' + value;
			found = true;
		}
	}
	
	if (!found) {
		params.push(param + '=' + value);
	}
	
	newUrl = params[0];
	for (var i=1; i<params.length; i++) {
		if (i==1) {
			newUrl += '?' + params[i]
		}
		else {
			newUrl += '&' + params[i]
		}
	}
	
	return newUrl;
}

function reload(p1,v1, 
				p2,v2, 
				p3,v3, 
				p4,v4, 
				p5,v5) {
	url = window.location.href;
	
	if (p1!=undefined && v1!=undefined) {
		url = changeUrlParameter(url, p1, v1);
	}
	
	if (p2!=undefined && v2!=undefined) {
		url = changeUrlParameter(url, p2, v2);
	}
	
	if (p3!=undefined && v3!=undefined) {
		url = changeUrlParameter(url, p3, v3);
	}
	
	if (p4!=undefined && v4!=undefined) {
		url = changeUrlParameter(url, p4, v4);
	}
	
	if (p5!=undefined && v5!=undefined) {
		url = changeUrlParameter(url, p5, v5);
	}
	
	window.location.href = url;
}

function loadobjs(){
	if (!document.getElementById)
		return
	
	for (var i=0; i<arguments.length; i++){
		var file=arguments[i]
		var fileref=""
		if (loadedobjects.indexOf(file)==-1){ //Check to see if this object has not already been added to page before proceeding
			if (file.indexOf(".js")!=-1){ //If object is a js file
				fileref=document.createElement('script')
				fileref.setAttribute("type","text/javascript");
				fileref.setAttribute("src", file);
			}
			else if (file.indexOf(".css")!=-1){ //If object is a css file
				fileref=document.createElement("link")
				fileref.setAttribute("rel", "stylesheet");
				fileref.setAttribute("type", "text/css");
				fileref.setAttribute("href", file);
			}
		}
		if (fileref!=""){
			document.getElementsByTagName("head").item(0).appendChild(fileref)
			loadedobjects+=file+" " //Remember this object as being already added to page
		}
	}
}

function showProgress(incl,w,h){
	nsm(incl, 'no_esc');
/*	
	var obody=document.getElementsByTagName('body')[0];
	var obol=document.createElement('div');
	obol.setAttribute('id','ol');
	obol.style.display='block';
	obol.style.position='fixed';
	obol.style.top=0;
	obol.style.left=0;
	obol.style.zIndex=998;
	obol.style.width='100%';
	obol.style.height='100%';
	obol.style.backgroundImage='url(/static/images/overlay.png)';
	
	var content=document.createElement('div');
	content.setAttribute('id','msg_content');
	content.style.display='block';
	content.style.position='fixed';
	content.style.top=(pageHeight()-h)/3 + 'px';
	content.style.left=(pageWidth()-w)/2 + 'px';
	content.style.width=w+'px';
	content.style.height=h+'px';
	content.setAttribute("class", 'progress-box'); //For Most Browsers
	content.setAttribute("className", 'progress-box'); //For IE; harmless to other browsers.
	obol.appendChild(content);
	
	content.innerHTML = document.getElementById(incl).innerHTML;
	obody.appendChild(obol);
*/
}

function showProgressAndSubmit(incl,w,h,frm){
	showProgress(incl,w,h);
	setTimeout("doSubmit('"+frm+"', '');",100); 
}

if (typeof String.prototype.startsWith != 'function') {
	String.prototype.startsWith = function (str){
		return this.slice(0, str.length) == str;
	};
}

if (typeof String.prototype.endsWith != 'function') {
	String.prototype.endsWith = function (str){
		return this.slice(-str.length) == str;
	};
}

function case_insensitive_compare(a,b) {
	a = a.toLowerCase();
	b = b.toLowerCase();
	
	if (a < b) {
		return -1;
	}
	else if (a > b) {
		return 1;
	} 
	else {
		return 0;
	}
}

function case_insensitive_suggestion_compare(a,b) {
	a = a.value.toLowerCase();
	b = b.value.toLowerCase();
	
	if (a < b) {
		return -1;
	}
	else if (a > b) {
		return 1;
	} 
	else {
		return 0;
	}
}

function jsSafeStr(s) {
//	s = s.replace("'", "&apos;");
//	s = s.replace("\"", "&quot;");
	
	s = psReplaceAll(s, "'", "&apos;");
	s = psReplaceAll(s, "\"", "&quot;");
	
	return s;
}

(function($) {
    $.fn.hasHScrollBar = function() {
        return this.get(0).scrollWidth > this.width();
    }
})(jQuery);

(function($) {
    $.fn.hasVScrollBar = function() {
        return this.get(0).scrollHeight > this.height();
    }
})(jQuery);

function exists(id) {
	return document.getElementById(id)!=null;
}

function addIDToMultipartForms(id) {
	forms = $('form');
	for (var i=0; i<forms.length; i++) {
		enctype = forms[i].enctype;
		
		if (enctype.indexOf('multipart')>=0) {
			action = forms[i].action;
			if (action.indexOf('fdid=')<0) {
				if (action.indexOf('?')<0) {
					action += '?fdid=' + id
				}
				else {
					action += '&fdid=' + id
				}
				
				forms[i].action = action;
			}
		}
	}
}

$.fn.hideFlex = function() {
	this.removeClass('d-flex');
	this.addClass('d-none');
};

$.fn.showFlex = function() {
	this.removeClass('d-none');
	this.addClass('d-flex');
};

$.fn.isVisible = function() {
	if (this.hasClass('d-none')) {
		return false;
	}

	if (this.css('display')=='none') {
		return false;
	}

	return true;
};

$.fn.makeRequired = function() {
	this.removeClass('ps-input-optional');
	this.addClass('ps-input-required');
};

$.fn.makeOptional = function() {
	this.removeClass('ps-input-required');
	this.addClass('ps-input-optional');
};

$.fn.setEnable = function() {
	var enabled = true;
	var o = this.get(0);
	if (o!=null) {
		if (o.tagName=='A') {
			$(this).removeClass('disabled');
		}
		else {
			this.removeClass('text-disabled');
			o.disabled = !enabled;
			if (enabled) {
				o.style.backgroundColor = editBgColour;
			}
			else if (o.type!=undefined) {
				o.style.backgroundColor = '#eee';
			}
	
			if (o.type=='textarea') {
				var ed = tinymce.get(id);
				if (ed!=null) {
					if (enabled) {
						ed.getBody().style.backgroundColor = editBgColour;
					}
					else {
						ed.getBody().style.backgroundColor = "#eee";
					}
				}
			}
		}
	}
}

$.fn.setDisable = function() {
	var enabled = false;
	var o = this.get(0);
	if (o!=null) {
		if (o.tagName=='A') {
			$(this).addClass('disabled');
		}
		else {
			this.addClass('text-disabled');
			o.disabled = !enabled;
			if (enabled) {
				o.style.backgroundColor = editBgColour;
			}
			else if (o.type!=undefined) {
				o.style.backgroundColor = '#eee';
			}
	
			if (o.type=='textarea') {
				var ed = tinymce.get(id);
				if (ed!=null) {
					if (enabled) {
						ed.getBody().style.backgroundColor = editBgColour;
					}
					else {
						ed.getBody().style.backgroundColor = "#eee";
					}
				}
			}
		}
	}
}

$.fn.changeEnable = function(e) {
	if (e) {
		this.setEnable();
	}
	else {
		this.setDisable();
	}
}

function closeAllToolbars() {
	$('.ps-toggle-box').addClass('hidden-box');
}

$.fn.enableBtn = function() {
	$(this).removeClass('disabled');
	$(this).prop('disabled', false);
}

$.fn.disableBtn = function() {
	$(this).addClass('disabled');
	$(this).prop('disabled', true);
}


$.fn.refreshClrBtn = function() {
	// Input
	if ($(this).get(0).type=='text') {
		var id = $(this).prop('id');
		var val = $(this).val();
	
		if (val=='') {
			$('#' + id + '_ClearBtn').disableBtn();
		}
		else {
			$('#' + id + '_ClearBtn').enableBtn();
		}
	}
	// Combobox
	else {
		var id = $(this).prop('id');
		var idx = $(this).prop('selectedIndex');

		if (idx==0) {
			$('#' + id + '_ClearBtn').disableBtn();
		}
		else {
			$('#' + id + '_ClearBtn').enableBtn();
		}
	}
}


$.fn.enableContainer = function() {
	var lst = $(this).find('input');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).setEnable();
		$(lst[i]).removeClass('text-disabled');
	}

	var lst = $(this).find('button');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).setEnable();
		$(lst[i]).removeClass('text-disabled');
	}

	var lst = $(this).find('select');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).setEnable();
		$(lst[i]).removeClass('text-disabled');
	}

	var lst = $(this).find('label');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).removeClass('text-disabled');
	}

	var lst = $(this).find('.label');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).removeClass('text-disabled');
	}

	var lst = $(this).find('.ps-label');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).removeClass('text-disabled');
	}
}

$.fn.disableContainer = function() {
	var lst = $(this).find('input');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).setDisable();
		$(lst[i]).addClass('text-disabled');
	}

	var lst = $(this).find('button');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).setDisable();
		$(lst[i]).addClass('text-disabled');
	}

	var lst = $(this).find('select');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).setDisable();
		$(lst[i]).addClass('text-disabled');
	}

	var lst = $(this).find('label');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).addClass('text-disabled');
	}

	var lst = $(this).find('.label');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).addClass('text-disabled');
	}

	var lst = $(this).find('.ps-label');
	for (var i=0; i<lst.length; i++) {
		$(lst[i]).addClass('text-disabled');
	}
}

function enableTinyMCE(id) {
	var ed = tinymce.get(id);
	if (ed!=null) {
		ed.setMode('design');
		$('#' + id + '_ifr').css('background-color', editBgColour);
		var body = ed.getBody();
		if (body!=null) {
			body.style.color = "#444";
		}
	}
}

function disableTinyMCE(id) {
	var ed = tinymce.get(id);
	if (ed!=null) {
		ed.setMode('readonly');
		$('#' + id + '_ifr').css('background-color', '#eee');
		var body = ed.getBody();
		if (body!=null) {
			body.style.color = "#888";
		}
	}
}

$.fn.setBootstrapToggle = function(val) {
	var isDisabled = $(this).get(0).disabled;

	$(this).bootstrapToggle('enable');
	if (val==true) {
		$(this).bootstrapToggle('on');
	}
	else {
		$(this).bootstrapToggle('off');
	}
	
	if (isDisabled) {
		$(this).bootstrapToggle('disable');
	}
}

var multiTabLogged = false;
function logMultiTab(path) {
	if (multiTabLogged) {
		return;
	}
	
	$.ajax({
		url: path + "/multitab.htm",
		context: document.body
	}).done(function(data) {
		multiTabLogged = true;
	});
}

function getCurrentTimestamp() {
	var now = new Date();
	var timeStamp = 'ts' + dateFormat(now, 'HHMMssl');
	return timeStamp;
}

var pageStamp = getCurrentTimestamp();
setCookie('pageStamp', pageStamp);

function checkMultiSessions(path) {
	var savedStamp = getCookie('pageStamp', pageStamp);
	setValue('pageStamp', pageStamp);

	if (savedStamp != pageStamp) {
		if (pageStamp>savedStamp) {
			logMultiTab(path);
		}
		
		$('#multipleTabsDlg').openDlg();
	}

	setTimeout("checkMultiSessions('" + path + "');", 1000);
}

function sleep(milliseconds) {
	var start = new Date().getTime();
	for (var i = 0; i < 1e7; i++) {
		if ((new Date().getTime() - start) > milliseconds) {
			break;
		}
	}
}

function strToTime(sTime, amBase) {
	// Remove all spaces
	while (sTime.indexOf(' ')>=0) {
		sTime = sTime.replace(' ', '');
	}

	// Remove all dots
	while (sTime.indexOf('.')>=0) {
		sTime = sTime.replace('.', '');
	}

	// Convert to lower case
	sTime = sTime.toLowerCase();
	
	var ampm = '';
	
	// Remove am/pm
	if (sTime.indexOf('pm')>=0) {
		ampm = 'pm';
		sTime = sTime.replace('pm', '');
	}
	else if (sTime.indexOf('p')>=0) {
		ampm = 'pm';
		sTime = sTime.replace('p', '');
	}
	else if (sTime.indexOf('am')>=0) {
		ampm = 'am';
		sTime = sTime.replace('am', '');
	}
	else if (sTime.indexOf('a')>=0) {
		ampm = 'am';
		sTime = sTime.replace('a', '');
	}

	// Time cannot be blank
	if (sTime=='') {
		return 'E Blank';
	}

	// Make sure it only contains ':' and '0'..'9'
	for (var i=0; i<sTime.length; i++) {
		var ch = sTime.charAt(i);
		if (ch!=':' && !(ch>='0' && ch<='9')) {
			return 'E Invalid';
		}
	}

	var h = 0;
	var m = 0;
	
	if (sTime.indexOf(':')>=0) {
		var parts = sTime.split(':');
		
		if (parts.length>2) {
			return 'E Invalid';
		}
		
		h = parseInt(parts[0]);
		m = parseInt(parts[1]);
	}
	else if (sTime.length<3) {
		h = parseInt(sTime);
		m = 0;
	}
	else if (sTime.length==3) {
		h = parseInt(sTime.substr(0,1));
		m = parseInt(sTime.substr(1,2));
	}
	else if (sTime.length==4) {
		h = parseInt(sTime.substr(0,2));
		m = parseInt(sTime.substr(2,2));
	}
	else {
		return 'E Invalid';
	}
	
	if (isNaN(h) || isNaN(m)) {
		return 'E Invalid';
	}
	
	if (ampm=='am' && h>12) {
		return 'E Invalid';
	}
	else if (ampm=='pm' && h==0) {
		return 'E Invalid';
	}
	else if (h>23 || m>59) {
		return 'E Invalid';
	}
	
	if (h==12 && ampm=='am') {
		h=0;
	}

	// Example:
	// amBase = 8 -> 8:30 is AM but 7:30 is PM
	if (ampm=='' && h<12 && h>=amBase) {
		ampm = 'am';
	}
	else if (ampm=='' && h<12) {
		ampm = 'pm';
	}
	else if (ampm=='' && h==12) {
		ampm = 'pm';
	}
	else if (h>12) {
		ampm = 'pm';
		h -= 12;
	}
	
	if (m<10) {
		m = '0' + m;
	}
	
	return h + ':' + m + ' ' + ampm;
}

$.fn.setGlyphCheck = function(val) {
	var parent = $(this).parents('.chkContainer');

	if (val==true && $(parent).hasClass('checked')==true) {
		return
	}	
	else if (val==false && $(parent).hasClass('checked')==false) {
		return
	}	
		
	$(parent).toggleClass('checked');
		
	var cb = $(parent).find('input');
	cb.prop('checked', !cb.prop('checked')).triggerHandler('change');
}

$.fn.isGlyphChecked = function() {
	var parent = $(this).parents('.chkContainer');

	return $(parent).hasClass('checked');
}


var itemCodeToDelete = '';
function removeListItem() {
	$('#lstItem_' + itemCodeToDelete).addClass('d-none');
	$('#lstItem_' + itemCodeToDelete).detach();
}

function ajaxDeleteItem(url, p1, p2, p3) {
	itemCodeToDelete = '';
	
	if (p1!=null && p1!=undefined && p1!='') {
		itemCodeToDelete = p1;
	}

	if (p2!=null && p2!=undefined && p2!='') {
		itemCodeToDelete = itemCodeToDelete + '_' + p2;
	}

	if (p3!=null && p3!=undefined && p3!='') {
		itemCodeToDelete = itemCodeToDelete + '_' + p3;
	}
	
	url = url.replace('_p1_', p1);
	url = url.replace('_p2_', p2);
	url = url.replace('_p3_', p3);

	$('#lstItem_' + itemCodeToDelete).html('<h4 class="p-2 text-muted">Deleting...</h4>');

	ajaxLoad(url,
			 null,
			 removeListItem);
}

function enableAllInputs() {
	$('.ps-input').each(function() {
		$(this).prop('disabled', false);
	});
}

function filterList(val) {
	if (val=='') {
		$('.list-group-item').removeClass('d-none');
	}
	else {
		var list = $('.list-group-item');
		val = val.toLowerCase();
	
		for (var i=0; i<list.length; i++) {
			var data = $(list[i]).find('.list-filter-value');
			
			var matchFound = false;

			for (var n=0; n<data.length; n++) {
				var values = ' ' + $(data[n]).html().toLowerCase().trim();
				values = values.replace(/['\-','\(','\[','\"','\.','\n','\r']/g, ' ');

				if (values.indexOf(' '+val)!=-1) {
					matchFound = true;
				}
			}

			if (matchFound==false) {
				$(list[i]).addClass('d-none');
			}
			else {
				$(list[i]).removeClass('d-none');
			}
		}
	}
}

function filterTable(val) {
	if (val=='') {
		$('.tbl-row').removeClass('d-none');
	}
	else {
		var list = $('.tbl-row');
		val = val.toLowerCase();
	
		for (var i=0; i<list.length; i++) {
			var data = $(list[i]).find('.list-filter-value');
			
			var matchFound = false;

			for (var n=0; n<data.length; n++) {
				if ($(data[n]).html().toLowerCase().indexOf(val)!=-1) {
					matchFound = true;
				}
			}
			
			if ($(list[i]).hasClass('tbl-header-row')) {
				// Keep headers.
			}
			else if (matchFound==false) {
				$(list[i]).addClass('d-none');
				$(list[i]).removeClass('d-flex');
			}
			else {
				$(list[i]).removeClass('d-none');
				$(list[i]).addClass('d-flex');
			}
		}
	}
}

jQuery.fn.selectText = function() {
    this.find('input').each(function() {
        if($(this).prev().length == 0 || !$(this).prev().hasClass('p_copy')) { 
            $('<p class="p_copy" style="position: absolute; z-index: -1;"></p>').insertBefore($(this));
        }
        $(this).prev().html($(this).val());
    });
    var doc = document;
    var element = this[0];
    console.log(this, element);
    if (doc.body.createTextRange) {
        var range = document.body.createTextRange();
        range.moveToElementText(element);
        range.select();
    } else if (window.getSelection) {
        var selection = window.getSelection();        
        var range = document.createRange();
        range.selectNodeContents(element);
        selection.removeAllRanges();
        selection.addRange(range);
    }
};

jQuery.fn.copyToClipboard = function() {
	$(this).selectText();
	document.execCommand("copy");
	document.getSelection().removeAllRanges();
};

$.fn.getIndex = function() {
	var id = $(this).attr('id');
	var numStr = '';
		
	for (var i=0; i<id.length; i++) {
		var ch = id.charAt(i);
		if (ch>='0' && ch<='9') {
			numStr = numStr + ch;
		}
	}
		
	return parseInt(numStr);
}

function psReplaceAll(txt, sub, rep) {
	if (txt==null || txt=='') {
		return txt;
	}

	var pos = 0;
	
	while ((pos=txt.indexOf(sub,pos))>=0) {
		var tmp1 = txt.substring(0, pos);
		var tmp2 = txt.substring(pos+sub.length, txt.length);
        
        txt = tmp1 + rep + tmp2;
        
		pos += rep.length;
	}

	return txt;
}

function readXML(xml, field) {
	var parser = new DOMParser();
	var xmlDoc = parser.parseFromString(xml, 'text/xml');
	
	var e = xmlDoc.getElementsByTagName(field);

	if (e==null || e.length==0) {
		return null;
	}
	
	return e[0].childNodes[0].nodeValue;
}

function readHTMLClassAttr(html, cls, atr) {
	var parser = new DOMParser();
	var xmlDoc = parser.parseFromString('<x>' + html + '</x>', 'text/html');
	
	var e = xmlDoc.getElementsByClassName(cls);

	if (e==null || e.length==0) {
		return null;
	}
	
	return $(e[0]).attr(atr);
}
